<?php
require 'vendor/autoload.php';

use GuzzleHttp\Client;
use GuzzleHttp\RequestOptions;
use NeutrinoAPILib\NeutrinoAPIClient;



// ELASTIC
const ELASTIC_API_URL = 'https://api.elasticemail.com';
const ELASTIC_ACCOUNT_ID = '2f55df83-63e3-4aa5-86cb-8ca7f2024298';



// URL parameters
$phone = $_GET['phone'];
$email = $_GET['email'];
$name = $_GET['name'] ?? '';
$firstName = $_GET['firstName'] ?? '';
$lastName = $_GET['lastName'] ?? '';
$date = $_GET['date'] ?? (new DateTime())->format('d.m.Y');
$geo = $_GET['geo'] ?? '';
$lng = $_GET['lng'] ?? '';
$link = $_GET['link'] ?? '';
$ref = $_GET['ref'] ?? '';
$sub1 = $_GET['sub1'] ?? '';
$sub2 = $_GET['sub2'] ?? '';

// secure methods 
if ($firstName == '') die;
if (strpos($email, '@knowledgemd.com') !== false)  die;


// Redirect url
const REDIRECT_URL = "https://bc.game/i-zmj211ch-n/";

// Landing Page
const Landing_ID = "BTC_CHAT_GPT_1";




// Enable services

$database       = TRUE;
$elastic        = FALSE;
$sendleadaivix  = FALSE;

header('Content-Type: application/json');
if ($email) {
    
    $resultneutrinoCheckPhone = neutrinoCheckPhone($phone);
    $ipInfo = neutrinoIpInfo();
	$geo = $ipInfo->countryCode;
	
    $validMailInfo = neutrinoCheckEmail($email);

    if ($validMailInfo->valid) {
        
       if (!$duip){
        $json = debounceCheckEmail($email);
	    $success = $json['success'];
        $result = $json['debounce'];
        //$result['code'] = '0';
           
       } else $result['code'] = '0';

        // Save to the list
        if ($result['code'] == '5' || $result['code'] == '0') processTracking();

        
        if ($elastic && ($result['code'] == '5' || $result['code'] == '0') && $duip != 1) {
            elasticSubscribe($email, $name, $date, $geo, $lng, $link, $phone);
        }


        if ($database) {
            $intnumber = $resultneutrinoCheckPhone->internationalNumber;
            $type = $resultneutrinoCheckPhone->type;
            $phone  = $resultneutrinoCheckPhone->internationalNumber;
            $info['prefix'] = $resultneutrinoCheckPhone->internationalCallingCode;
            $info['local']  = $resultneutrinoCheckPhone->localNumber;
            $info['sid']    = $_GET['affid'];
            $info['cid']    = $_GET['tag'];
            $info['sub1']   = $_GET['sub1'];
            $info['sub2']   = $_GET['sub2'];
            $info['ref']    = $_GET['ref'];
            $info['lp']     = Landing_ID;

            $userid = saveToDB($phone, $email, $firstName, $lastName, $ip, $geo, $info);
        }
        
        $link = REDIRECT_URL; 

        if ($result['code'] == '5' || $result['code'] == '0'){
            $response = array(
				'success' => true,

				'redirect' => $link
			);
		   echo json_encode($response);
        }

        
        
        if ($result['code'] != '5' && $result['code'] != '0'){
            $response = array(
				'success' => false,
				'error' => 'Email not validated',
			);
			http_response_code(400);
			echo json_encode($response);
        }

        
    } else {
        $response = array(
            'success' => false,
            'error' => 'Email not validated',
        );
        http_response_code(500);
        echo json_encode($response);
    }
} else {
    $response = array(
        'success' => false,
        'error' => 'No email or phone provided',
    );
    http_response_code(400);
    echo json_encode($response);
}


// **** NEUTRINO ****
function neutrinoCheckPhone($phone) {
    $ip = $_SERVER['REMOTE_ADDR'];
    $userId = 'antonluki';
    $apiKey = 'h9oeSHHuEs7IcXtrykYnO9t74KZaU1wMetak8CMoVcCUvpus';

    $client = new NeutrinoAPIClient($userId, $apiKey);

    $dataTools = $client->getDataTools();

    $result = $dataTools->phoneValidate($phone, null, $ip);

    return $result;
}


function neutrinoIpInfo() {
    $ip = $_SERVER['REMOTE_ADDR'];
    $userId = 'antonluki';
    $apiKey = 'h9oeSHHuEs7IcXtrykYnO9t74KZaU1wMetak8CMoVcCUvpus';

    $client = new NeutrinoAPIClient($userId, $apiKey);

    $dataTools = $client->getGeolocation();

    $result = $dataTools->iPInfo($ip);

    return $result;
}

function neutrinoCheckEmail($email) {
    $userId = 'antonluki';
    $apiKey = 'h9oeSHHuEs7IcXtrykYnO9t74KZaU1wMetak8CMoVcCUvpus';

    $client = new NeutrinoAPIClient($userId, $apiKey);

    $dataTools = $client->getDataTools();

    $result = $dataTools->emailValidate($email);

    return $result;
}




// **** DEBOUNCE ****
function debounceCheckEmail($email) {
    $api = '62c2fdbcd5dc6';
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, 'https://api.debounce.io/v1/?api=' . $api . '&email=' . strtolower($email));
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);

    $data = curl_exec($ch);
    curl_close($ch);

    return json_decode($data, true);
}

// **** TRACKING ****
function processTracking() {

    $affid = $_GET['affid'];
    $tag = $_GET['tag'];

    $value = 0.5;
    if ($affid == 6)  $pixel = "http://main.exoclick.com/tag.php?goal=bcd0049c35799cdf57d06eaf2eb3cff6&tag=$tag";
    if ($affid == 16) $pixel = "https://tsyndicate.com/api/v1/cpa/action/$tag?value=$value&key=WbCW2Vyncw1PD7iQHi74AxgQT04C6MzSO2DF";
    if ($affid == 3)  $pixel = "https://prprocess.com/conversion/?user_id=4055&click_id=$tag&currency=USD&payout=$value";
    if ($affid == 4)  $pixel = "https://ck.juicyads.com/ilikeitjuicy.php?u=11273&s2s=$tag&amount=$value&token=46bc9a3d4222fbcc9d88c7aa8ae7d1aa&data=52c69d19d4e4dc2a550005b33c960ad8";
    if ($affid == 7)  $pixel = "https://ero-analytics.com/tracking/conv.php?cid=$tag&conv_type=a";
    if ($affid == 13) $pixel = "http://ads.adamoads.com/goal_tracker.php?goal=bca82e41ee7b0833588399b1fcd177c7&code=$tag";
    if ($affid == 5)  $pixel = "http://serve.popads.net/cpixel.php?s2s=1&aid=d1919f5f6c957e762869ac492a113099&id=$tag&value=$value";
    if ($affid == 11) $pixel = "http://sconvtrk.com/conversion/20852100607f02aee0488298fc12ae8f5f56f335/?visitor_id=$tag&aid=104434";
    if ($affid == 22) $pixel = "http://ad.propellerads.com/conversion.php?aid=27243&pid=&tid=25202&visitor_id=$tag&value=$value";
    if ($affid == 23) $pixel = "http://main.exoclick.com/tag.php?goal=115fe3d68982c3c0b666ae3aaaa58213&tag=$tag";
    if ($affid == 24) $pixel = "http://peppx.ab4all.com/trackpixel/track?tid=$tag&amt=$value";
    if ($affid == 25) $pixel = "http://a.adskeeper.co.uk/postback?c=$tag&e=lead195446";
    if ($affid == 26) $pixel = "https://ct.popcash.net/click?aid=127826&clickid=$tag&payout=$value";
    if ($affid == 27) $pixel = "https://hilltopads.com/conversion/close/master?token=$tag";
    if ($affid == 226 || $affid == "") $pixel = "http://main.exoclick.com/tag.php?goal=41e61295266e16e43e52f7adc4debb71&tag=$tag";

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $pixel);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_exec($ch);
    curl_close($ch);
}

// **** elasticemail ****
function elasticSubscribe($email, $name, $date, $geo, $lng, $link, $phone)
{
    // Create a Guzzle client
    $client = new GuzzleHttp\Client();

    $data = array(
        'publicAccountID' => ELASTIC_ACCOUNT_ID,
        'email' => $email,
        'firstName' => $name,
        'sendActivation' => false,
        'field_date' => $date,
        'field_geo' => $geo,
        'field_lng' => $lng,
        'field_link' => $link,
        'field_phone' => $phone,
    );

    $client->get(ELASTIC_API_URL . '/v2/contact/add', [
        RequestOptions::QUERY => $data
    ]);
}








// **** DATABASE ****



function checkduplicate($email){
    
    include "db_con.php";

    $exist = FALSE;

    $sql = "SELECT email FROM data WHERE email='$email' LIMIT 1";
    $result = mysqli_query($conn, $sql);

    return mysqli_num_rows($result) > 0;
    
    return 0;

}



// **** DATABASE ****
function saveToDB($phone, $email, $firstName, $lastName, $ip, $geo, $info)
{


   include "db_con.php";

    $exist = FALSE;

    $sql = "SELECT email FROM data WHERE email='$email'";
    $result = mysqli_query($conn, $sql);

    $exist = mysqli_num_rows($result) > 0;


    if (!$exist) {
		
        $ip   = $_SERVER['REMOTE_ADDR'];
        $geo  = $info['geo'];
		$cid  = $info['cid'];
		$sid  = $info['sid'];
		$lp   = $info['lp'];
		$sub1 = $info['sub1'];
		$sub2 = $info['sub2'];
		$prefix = $info['prefix'];
		$local = $info['local'];

        $sql = "INSERT INTO data (email,firstName,lastName,prefix,local,phone,ip,geo,lp,sid,cid,sub1,sub2) VALUES ('$email','$firstName','$lastName','$prefix','$local','$phone','$ip','$geo','$lp','$sid','$cid','$sub1','$sub2')";

        if (!mysqli_query($conn, $sql)) {
            $response = array(
                'success' => false,
                'error' => $sql . "<br>" . mysqli_error($conn),
            );
            http_response_code(500);
            echo json_encode($response);
			$last_id = $conn->insert_id;
			return $last_id;
        }
	//	$leadstatus = sendlead($email,$name,$phone,$geo);
    } else {

        /*$sql = "UPDATE data SET count=count+1 WHERE email='$email'";

        if (!mysqli_query($conn, $sql)){
            $response = array(
                'success' => false,
                'error' => $sql . "<br>" . mysqli_error($conn),
            );
            http_response_code(500);
            echo json_encode($response);
        }*/
    }

    mysqli_close($conn);
}


function sendlead($data){
    
$firstName = lcfirst($data['firstName']); 
$lastName  = lcfirst($data['lastName']);
$email     = $data['email'];
$password  = "1341234Ab";
$geo       = $data['geo'];

$phone       = $data['local'];
$phonecc     = $data['prefix'];

$lp        = "https://lp.financeop.com/epcclub/3/";
$ip        = $data['ip'];

    $URL = 'https://hypymopy.ciperyur.com/tracker';
    $apiData = array(
        'first_name' => $firstName,
        'last_name' => $lastName,
        'email' => $email,
        'password' => $password,
        'phonecc' => $phonecc,
        'phone' => $phone,
        'country' => $geo,
        'user_ip' => $ip,
        'aff_sub3' => $lp,
        'aff_id' => '23451', // do not change
        'offer_id' => '1737', //dont change !
    );
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $URL . '?' . http_build_query($apiData));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    $response = curl_exec($ch);
    
     print("<pre>".print_r($apiData,true)."</pre>");


return $response;
    
    
}


